#!/usr/local/bin/io

doFile("const.io")
doFile("lfile.io")
doFile("serialize.io")
doFile("login.io")
doFile("graph.io")

doFile("CGI.io")

TICKETS := List clone add("taxi", "bus", "ug")
LABELS := Map clone atPut("taxi", "TAXI") atPut("bus", "BUS") atPut("ug", "U-GROUND") atPut("bt", "BLACK")

ErrMsg := Warning clone do(
  name := ""
  description := ""

  setName := method(n,
    name = n
    self
  )

  add := method(a,
    description = description .. a .. "<br>"
  )

  raise := method(n, d,
    if(n, name = n)
    if(d, description = d)
    if(description != "", super raise(name, description))
  )
)

Yard := Object clone do(
  type := "Yard"

  yidLink := method(
    yidStr := yid asString
    "<a href=\"syard.cgi?yid=" .. yidStr .. "\">" .. yidStr .. " " .. name .. "</a>"
  )

  player := method(l,
    p := Nil
    if(l hasProto(String)) then(
      p = players detect(i, p, p userid == l)
    ) else(
      p = players detect(i, p, p userid == l userid and(p passwd == l passwd))
    )
    ctrl := Syard params at("ctrl")
    if(ctrl) then(
      if(p and(p isAgent)) then(
        return players detect(i, p, p userid == ctrl)
      ) else(
        Warning raise("Բ", "ʤϤΥȤǤޤ")
      )
    )
    return p
  )

  visibles := method(l, hour,
    t := if (hour == (-1), turn, hour)
    players select(i, p,
      if(hour == (-1) and(p actioned), t = t + 1)
      p isAgent or(t == 3) or(t == 8) or(t == 13) or(t == 18) or (t == 24) or(state > 1) or(p userid == l userid and(p passwd == l passwd))
    )
  )

  mrX := method(
    players detect(i, p, p isMrX)
  )

  playerPos := method(pos,
    players detect(i, p, p pos == pos)
  )

  serialize := method(
    Serialize dump(self, "db/" .. yid asString .. ".db")
  )

  loadGraph := method(
    Graph clone load("data/" .. map .. "/map.dat")
  )
)

Player := Object clone do(
  init := method(
    self tickets := Map clone atPut("taxi", 10) atPut("bus", 8) atPut("ug", 4)
    self actioned := Nil

    self poses := List clone
    self moves := List clone
  )

  img := method(
    "data/player" .. num asString .. ".gif"
  )

  isMrX := Nil
  isAgent := Nil

  posHour := method(h,
    if(h == -1, return pos)
    while(poses at(h) isNil, h = h - 1)
    return poses at(h)
  )
)

Agent := Player clone do(
  type := "Agent"
  isAgent = 1

  init := method(
    super init
    self tickets atPut("bt", 0)
  )
)

MrX := Player clone do(
  type := "MrX"
  isMrX = 1

  init := method(
    super init
    self tickets atPut("bt", 5)
    self doubles := 2
  )
)

Syard := Object clone do(
  params := CGI parse

  login := Login get(params)

  yid := params at("yid")

  printCookie := method(
    if(login hasSlot("cookie"), write(login cookie))
  )

  printHeader := method(
    printCookie
    write("Content-Type: text/html\r\n\r\n")
  )

  loadYard := method(
    doFile("db/" .. yid asString .. ".db")
  )

  yards := method(
    yards := List clone
    yfile := LFile clone setPath("db/yard.db")
    if(yfile exists,
      yfile readTransaction(
        while(line := yfile readLine,
          a := line split("\t")
          y := Yard clone
          y yid := a at(0) asNumber
          y name := a at(1) asString
          y state := a at(2) asNumber
          y comment := a at(3) asString
          yards add(y)
        )
      )
    )
    yards
  )

  updateState := method(s,
    ys := yards
    ysfile := LFile clone setPath("db/yard.db")
    ysfile writeTransaction(
      ys foreach(i, y,
        if(y yid == yid asNumber, y state = s)
        ysfile write(y yid asString, "\t", y name, "\t", y state asString, "\t", y comment, "\n")
      )
    )
  )

  getFirstPos := method(
    firsts := List clone add(13, 26, 29, 34, 50, 53, 91, 94, 103, 112, 117, 132, 138, 141, 155, 174, 197, 198)
    firsts at(Random value(firsts count) floor)
  )

  handle_mkyard := method(
    lastYard := yards last
    mkyid := if(lastYard, (lastYard yid) + 1, 100) asString
    name := params at("name")
    userid := params at("userid")
    passwd := params at("passwd")
    comment := params at("comment")

    errmsg := ErrMsg clone setName("̤Ϲ")
    if(name == Nil, errmsg add("̾ϤƲ"))
    if(userid == Nil, errmsg add("桼̾ϤƲ"))
    if(passwd == Nil, errmsg add("ѥɤϤƲ"))
    if(comment == Nil, errmsg add("ȤϤƲ"))
    errmsg raise

    ysfile := LFile clone setPath("db/yard.db")
    ysfile appendTransaction(
      ysfile write(mkyid, "\t", name, "\t0\t", comment, "\n")
    )

    pos := getFirstPos
    y := Yard clone
    y yid := mkyid asNumber
    y name := name
    y state := 0
    y turn := 0
    y comment := comment
    y map := "default"
    x := MrX clone
    x init
    x userid := userid
    x passwd := passwd
    x pos := pos
    x poses add(pos)
    x num := 0
    y players := List clone add(x)
    y serialize
  )

  handle_login := method(
    yard := loadYard

    if(yard player(login userid),
      if(yard player(login),
        return,
        Warning raise("Բ", "ѥɤְäƤޤ")))

    if(yard players count == 6,
      Warning raise("Բ", "6ͤäƤޤ"))

    if(yard players count == 5,
      yard state = 1
      updateState(1)
    )

    a := Agent clone
    a init
    a userid := login userid
    a passwd := login passwd

    errmsg := ErrMsg clone setName("̤Ϲ")
    if(a userid == Nil or(a userid == "none"),
      errmsg add("桼̾ϤƲ"))
    if(a passwd == Nil or(a passwd == "none"),
      errmsg add("ѥɤϤƲ"))
    errmsg raise

    pos := getFirstPos
    while(yard playerPos(pos), pos = getFirstPos)
    a pos := pos
    a poses add(pos)
    a num := yard players count
    yard players add(a)
    yard serialize
  )

  handle_yid := method(
    yard := loadYard

    hour := params at("hour")
    if(hour, hour = hour asNumber, hour = -1)

    ctrl := params at("ctrl")

    player := yard player(login)

    write("<h1>Scotland Yard")
    if(hour == -1,
      write(" / ", yard yid, " ", yard name, "</h1>"),
      write(" / ", yard yid, " ", yard name, " - ", hour, "</h1>"))

    write("<p>")
    if (hour == -1) then(
      write("<a href=\"syard.cgi?yid=", yid, "&hour=", yard turn, "\">&lt;</a> ")
    ) elseif(hour != 0) then(
      write("<a href=\"syard.cgi?yid=", yid, "&hour=", hour - 1, "\">&lt;</a> ")
    )
    for(i, 0, yard turn + 1,
      if(hour == i) then(
        write(i, "-")
      ) elseif(hour == (-1) and(yard turn + 1 == i)) then(
        write(i)
      ) elseif(yard turn + 1 == i) then(
        write("<a href=\"syard.cgi?yid=", yid, "\">", i, "</a>")
      ) else(
        write("<a href=\"syard.cgi?yid=", yid, "&hour=", i, "\">", i, "</a>-")
      )
    )
    if (hour == yard turn) then(
      write(" <a href=\"syard.cgi?yid=", yid, "\">&gt;</a>")
    ) elseif(hour != -1) then(
      write(" <a href=\"syard.cgi?yid=", yid, "&hour=", hour + 1, "\">&gt;</a>")
    )
    write("</p>")

    g := yard loadGraph

    if(ctrl) then(
      write("<img name=\"map\" src=\"data/", yard map, "/map.png\" alt=\"yard\"  style=\"display:inline; position:relative; z-index:1; \" onClick=\"queryMap(event, ", yid, ", '", ctrl, "')\">")
    ) else(
      write("<img name=\"map\" src=\"data/", yard map, "/map.png\" alt=\"yard\"  style=\"display:inline; position:relative; z-index:1; \" onClick=\"queryMap(event, ", yid, ", null)\">")
    )

    write("<br>")

    yard visibles(login, hour) foreach(i, p,
      pos := g pos at((p posHour(hour)) - 1)
      x := (pos at(0) - i*21 - 10) asString
      y := (pos at(1) - 574 - 32) asString
      if(p isMrX) then(
        x = x - 5
        y = y - 1
      )
      write("<img src=\"", p img, "\" style=\"display:inline; position:relative; z-index:2; left:" .. x .. "px; top:" .. y .. "px;\"  alt=\"", p userid, "\">")
    )
    write("<br>")
    for(i, 0, 6,
      write("<img src=\"data/box_taxi.gif\" style=\"display:none; position:relative; z-index:3; \" alt=\"taxi\" id=\"taxi", i, "\">")
    )
    for(i, 0, 4,
      write("<img src=\"data/box_bus.gif\" style=\"display:none; position:relative; z-index:3;\" alt=\"bus\" id=\"bus", i, "\">")
    )
    for(i, 0, 3,
      write("<img src=\"data/box_ug.gif\" style=\"display:none; position:relative; z-index:3;\" alt=\"ug\" id=\"ug", i, "\">")
    )

    write("<br>")

    if(player,
      write("<p><img src=\"", player img, "\" alt=\"player\">", player type, "(", player userid, ") : ", player pos, "</p>")

      canMove := Nil
      if(yard state == 0) then(
        write("<p>ԤǤ</p>")
      ) elseif(yard state == 2) then(
        write("<p>Ȥޤ</p>")
      ) elseif(yard state == 3) then(
        write("<p>MrXޤ</p>")
      ) elseif(player actioned) then(
        write("<p>¾οʹ֤ιưԤǤ</p>")
      ) elseif(player isAgent and(yard mrX actioned isNil)) then(
        write("<p>MrXιưԤǤ</p>")
      ) else(
        canMove = 1
      )

      pos := player pos - 1

      write(
        """<form action="syard.cgi" method="GET">""",
        """<input type="hidden" name="cmd" value="move">""",
        "<input type=\"hidden\" name=\"yid\" value=\"", yid, "\">")
      if(ctrl) then(
        write("<input type=\"hidden\" name=\"ctrl\" value=\"", ctrl, "\">")
      )

      choice := block(a, t,
        num := player tickets at(t)
        if(a count > 0 and(num > 0)) then(
          write("<p>")
          if(canMove, write(
              "<input type=\"radio\" name=\"how\" value=\"", t, "\">"))
          write(
            LABELS at(t), ": ",
            "<select name=\"", t, "\">"
          )
          a foreach(i, v, write("<option value=\"", v, "\">", v, "</option>"))
          write("""</select>""")
          write(" (", num, ")")
          write("</p>")
        ) else(
          write("<p>", LABELS at(t), ": Բ (", num, ")</p>")
        )
      )

      choice(g taxi at(pos), "taxi")
      choice(g bus at(pos), "bus")
      choice(g ug at(pos), "ug")
      if(player isMrX,
        choice(g all(pos), "bt")
        write(
          """<p>Double Move: <input type="checkbox" name="double" value="1">""",
          " (", player doubles, ")</p>")
      )
      if(canMove, write("""<input type="submit" value="ư">"""))

      write("</form>")
    )

    colors := Map clone atPut("taxi", "000000") atPut("bus", "1ec81e") atPut("ug", "ff0000")

    if(yard state != 0,
      write("""<p><table border="1"><tr><th></th>""")
      yard players foreach(i, p,
        write("<th><img src=\"", p img, "\">")
        if(player and(player isAgent) and(p != player) and(p isAgent)) then(
          write("<a href=\"syard.cgi?yid=", yid, "&ctrl=", p userid, "\">", p userid, "</a><br>")
        ) else(
          write(p userid, "<br>")
        )
        TICKETS foreach(j, t,
          if(j != 0, write("/"))
          write("<font color=\"#", colors at(t), "\">", p tickets at(t), "</font>")
        )
        if(p isMrX, write("/", p tickets at("bt")))
        write("</th>")
      )
      write("</tr>")
      for(i, 0, yard turn + 1,
        write("<tr><td>", i, "</td>")
        yard players foreach(j, p,
          if(p poses at(i) isNil) then(
            write("<td> - </td>")
          ) else(
            posStr := ""
            if(p isAgent or(yard state > 1) or(player and(player isMrX)) or(i == 3) or(i == 8) or(i == 13) or(i == 18) or(i == 24)) then(
              posStr = p poses at(i) asString
            ) else(
              posStr = "???"
            )

            if(i != 0, posStr = LABELS at(p moves at(i-1)) .. " - " .. posStr)
            write("<td>", posStr, "</td>")
          )
        )
        write("</tr>")
      )
      write("</table></p>")
    )

    if(player,
      write("<p>")
      write(Const logout .. "<input type=\"hidden\" name=\"yid\" value=\"" .. yid asString .. "\"></form></p>")
      ,
      write("<p>", Const login .. "<input type=\"hidden\" name=\"yid\" value=\"" .. yid asString .. "\"></form></p>")
    )
  )

  handle_move := method(
    yard := loadYard
    player := yard player(login)
    g := yard loadGraph

    errmsg := ErrMsg clone setName("ưԲ")
    if(player isNil, errmsg add("󤷤Ƥޤ"))

    how := params at("how")
    if(how isNil, errmsg add("ưˡꤵƤޤ"))
    errmsg raise

    to := params at(how)
    if(to isNil, errmsg add("ư褬ꤵƤޤ"))
    to = to asNumber
    if(to == 0, errmsg add("ư褬Ǥ"))

    if(yard state == 0, errmsg("ϤƤޤ"))
    if(yard state > 1, errmsg("λƤޤ"))

    if(player actioned, errmsg add("˹ưѤߤǤ"))

    if(player isAgent and(yard mrX actioned isNil)) then(
      errmsg add("MrXιưԤǤ")
    )

    canMoves := if(how != "bt",
      g getSlot(how) at(player pos - 1),
      g all(player pos - 1))
    if(canMoves detect(i, p, p == to) isNil) then(
      errmsg add("ưǽʾǤ")
    )

    tnum := player tickets at(how)
    if(tnum isNil or(tnum == 0), errmsg add("åȤ­ޤ"))

    double := params at("double")
    if(double == "1") then(
      if(player isAgent,
        errmsg add("MrXǤʤȥ֥åȤϻȤޤ")
      ) elseif (player doubles == 0) then(
        errmsg add("֥åȤο­ޤ")
      )
    )

    coll := yard playerPos(to)
    if(coll) then(
      if(coll isAgent and(player isAgent)) then(
        errmsg add("ư˴˥Ȥޤ")
      ) else(
        yard state = 2
        updateState(2)
      )
    )

    errmsg raise

    if(double == "1") then(
      player doubles = player doubles - 1
      yard players foreach(i, p,
        p actioned = 1
        if(p isAgent) then(
          p moves add(Nil)
          p poses add(Nil)
        )
      )
    ) else(
      player actioned = 1
    )
    player moves add(how)
    player poses add(to)
    player pos = to
    player tickets atPut(how, tnum - 1)
    if(player isAgent) then(
      yard mrX tickets atPut(how, yard mrX tickets at(how) + 1)
    )

    if(yard players detect(i, p, p actioned isNil) isNil) then(
      if(yard turn == 23) then(
        yard state = 3
        updateState(3)
      ) else(
        yard turn = yard turn + 1
        yard players foreach(i, p,
          if(TICKETS detect(j, t,
              p tickets at(t) > 0 and(g getSlot(t) at(p pos - 1) count > 0)
            )
          ) then(
            p actioned = Nil
          )
        )
      )
    )

    yard serialize
  )

  handle_query := method(
    write("Content-Type: application/xml\r\n\r\n")
    write("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n")

    x := params at("x") asNumber
    y := params at("y") asNumber

    coord := params at("coord")

    yard := loadYard
    g := yard loadGraph

    minPos := -1
    minLen := 10000
    g pos foreach(i, p,
      dx := p at(0) - x
      dy := p at(1) - y
      d := ((dx * dx + dy * dy) sqrt)
      if(d < minLen) then(
        minPos = i + 1
        minLen = d
      )
    )
    pos := if(minLen < 10, minPos)

    write("<queryResult>")
//    write("<x>", x, "</x>")
//    write("<y>", y, "</y>")
    if(pos) then(
      write("<pos>", pos, "</pos>")

      write("<moves>")
      TICKETS foreach(i, t,
        write("<", t, ">")
        g getSlot(t) at(pos-1) foreach(j, p,
//          if (coord) then(
            ps := g pos at(p-1)
            write("<move>", ps at(0), ",", ps at(1) , "</move>")
//          ) else(
//            write("<move>", p, "</move>")
//          )
        )
        write("</", t, ">")
      )
      write("</moves>")

      p := yard player(login)
      if(coord isNil and(p) and(p actioned isNil)) then(
        write("<hows>")
        pp := p pos - 1
        hows := TICKETS select(i, t,
          p tickets at(t) > 0 and(g getSlot(t) at(pp) detect(j, q, q == pos))
        )
        hows foreach(i, t, write("<how>", t, "</how>"))
        if(p isMrX and(hows count > 0), write("<how>bt</how>"))
        write("</hows>")
      )
    )

    write("</queryResult>\n")
  )

  handle_index := method(
    write("<h1>Scotland Yard</h1>")
    write("<h2></h2>")
    write(
      "<table border=\"1\">",
      "<th>̾</th><th></th><th></th>"
    )
    yards reverseForeach(i, yard,
      write(
        "<tr>",
        "<td>", yard yidLink, "</td>",
        "<td>", Const stateStr at(yard state), "</td>",
        "<td>", yard comment, "</td>",
        "</tr>"
      )
    )
    write("</table>")

    write(Const mkyard)

    write(Const desc)
  )

  run := method(
    cmd := params at("cmd")
    if(cmd,
      try(
        if(cmd == "mkyard",
          handle_mkyard
        )
        if(cmd == "login",
          handle_login
        )
        if(cmd == "move",
          handle_move
        )
        if(cmd == "query",
          handle_query
          return
        )
      ) catch(Warning, w,
        printHeader
        write(Const title)
        write("<h2>", w name, "</h2>")
        write("<p>", w description, "</p>")
        write(Const foot)
        return
      ) catch(Exception, e,
        write("Content-Type: text/plain\r\n\r\n")
        e pass
      )
      write("Status Code: 302 Moved Temporary\r\n")
      printCookie
      ctrlParam := ""
      if(params at("ctrl"), ctrlParam = "&ctrl=" + params at("ctrl"))
      if(yid,
        write("Location: syard.cgi?yid=", yid, ctrlParam, "\r\n\r\n"),
        write("Location: syard.cgi", ctrlParam, "\r\n\r\n"))
      ,
      printHeader
      write(Const title)

      if(yid, handle_yid, handle_index)

      write(Const foot)
    )
  )
)

Random setSeed(Date now asNumber)

Syard run
