require 'sdl'

pos = Array.new
taxi = Array.new
bus = Array.new
ug = Array.new
File.open('map') do |mf|
  mf.each do |ml|
    ma = ml.split(/\t/)
    pos.push(ma[0].split(/,/).collect { |i| i.to_i*3/4 })
    taxi.push(ma[1].split(/,/).collect { |i| i.to_i }.delete_if { |i| i == 0 })
    bus.push(ma[2].split(/,/).collect { |i| i.to_i }.delete_if { |i| i == 0 })
    ug.push(ma[3].split(/,/).collect { |i| i.to_i }.delete_if { |i| i == 0 })
  end
end

num = 199

bp = Array.new
for i in 0...num
  bp.push([])
end
bp[107] = [115]
bp[114] = [108, 157]
bp[156] = [115, 194]
bp[193] = [157]

SDL.init(SDL::INIT_VIDEO)

s = SDL::setVideoMode(640, 480, 32, SDL::SWSURFACE)

red = s.mapRGB(255, 0, 0)
green = s.mapRGB(30, 200, 30)
white = s.mapRGB(255, 255, 255)
gray = s.mapRGB(128, 128, 128)
black = s.mapRGB(0, 0, 0)

s.fillRect(0, 0, 640, 480, gray)

# checking
for i in 0...num
  ug[i].each do |t|
    t -= 1
    raise "err #{i+1} - #{t+1}" if (!ug[t].find { |v| i+1 == v })
  end
  bus[i].each do |t|
    t -= 1
    raise "err #{i+1} - #{t+1}" if (!bus[t].find { |v| i+1 == v })
  end
  taxi[i].each do |t|
    t -= 1
    raise "err #{i+1} - #{t+1}" if (!taxi[t].find { |v| i+1 == v })
  end
  bp[i].each do |t|
    t -= 1
    raise "err #{i+1} - #{t+1}" if (!bp[t].find { |v| i+1 == v })
  end
end

for i in 0...num
  bp[i].each do |t|
    next if (t == 0)
    t -= 1
    s.drawLine(pos[i][0], pos[i][1], pos[t][0], pos[t][1], black)
  end
end

for i in 0...num
  ug[i].each do |t|
    next if (t == 0)
    t -= 1
    s.drawLine(pos[i][0]-2, pos[i][1]+2, pos[t][0], pos[t][1], red)
    s.drawLine(pos[i][0]+2, pos[i][1]+2, pos[t][0], pos[t][1], red)
    s.drawLine(pos[i][0]-2, pos[i][1]-2, pos[t][0], pos[t][1], red)
    s.drawLine(pos[i][0]+2, pos[i][1]-2, pos[t][0], pos[t][1], red)
    s.drawLine(pos[i][0]+1, pos[i][1]+1, pos[t][0], pos[t][1], red)
    s.drawLine(pos[i][0]-1, pos[i][1]+1, pos[t][0], pos[t][1], red)
    s.drawLine(pos[i][0]+1, pos[i][1]-1, pos[t][0], pos[t][1], red)
    s.drawLine(pos[i][0]-1, pos[i][1]-1, pos[t][0], pos[t][1], red)
  end
end

for i in 0...num
  bus[i].each do |t|
    next if (t == 0)
    t -= 1
    s.drawLine(pos[i][0]+1, pos[i][1]+1, pos[t][0], pos[t][1], green)
    s.drawLine(pos[i][0]-1, pos[i][1]+1, pos[t][0], pos[t][1], green)
    s.drawLine(pos[i][0]+1, pos[i][1]-1, pos[t][0], pos[t][1], green)
    s.drawLine(pos[i][0]-1, pos[i][1]-1, pos[t][0], pos[t][1], green)
  end
end

for i in 0...num
  taxi[i].each do |t|
    next if (t == 0)
    t -= 1
    s.drawLine(pos[i][0], pos[i][1], pos[t][0], pos[t][1], white)
  end
end

for i in 0..num
  if (ug[i] && ug[i].size > 0)
    s.drawFilledCircle(pos[i][0], pos[i][1], 12, red)
  end
end

for i in 0..num
  if (bus[i] && bus[i].size > 0)
    s.drawFilledCircle(pos[i][0], pos[i][1], 10, green)
  end
end

for i in 0..num
  next if (!pos[i])
  s.drawFilledCircle(pos[i][0], pos[i][1], 8, white)
end

font = SDL::BMFont.open('font.bmp', SDL::BMFont::TRANSPARENT)
font.setColor(0, 0, 0)

for i in 0..num
  next if (!pos[i])
  str = (i+1).to_s
  font.textout(s, str,
               pos[i][0]-font.width/2*str.size+1,
               pos[i][1]-font.height/2)
end

s.saveBMP('out.bmp')
